//
//  ChatViewController.h
//  template
//
//  Created by Andrea della Porta on 16/08/15.
//  Copyright (c) 2015 Ermes Italia. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "HTTP.h"
#import "PrivateData.h"
#import <AVFoundation/AVFoundation.h>
#import "NotifyItem.h"
#import <Pusher/Pusher.h>


@interface ChatViewController : UIViewController <UITextViewDelegate, UITableViewDelegate, HTTPDelegate, UITableViewDataSource, UIImagePickerControllerDelegate, PTPusherPresenceChannelDelegate>
{
    //UIScrollView *scrollView;
    UIImageView *imageView;
    NSMutableArray *images;
    NSMutableArray *descriptions;
    UITextView *textView;
}

@property NotifyItem *notifyItem;
@property (nonatomic, retain) AVPlayer *player;
@property UIView *playerView;

@property (weak, nonatomic) IBOutlet UIButton *homepageButton;
@property (weak, nonatomic) IBOutlet UILabel *homepageLabel;
@property (weak, nonatomic) IBOutlet UIScrollView *scrollView;

#define PUSHER_AUTH_URL BASE_SERVER_URL @"/" @"pusher/auth"
#define READ    3
#define SENT    1
#define UNKNOWN 0

- (void) refreshContainerHeight:(int)height;
+ (NSString *)usernameGet;
+ (void)usernameSet:(NSString *)name;
+ (NSString *)pwdGet;
+ (void)pwdSet:(NSString *)name;

@end
