//
//  HTTP.h
//  template
//
//  Created by Andrea della Porta on 19/08/15.
//  Copyright (c) 2015 Ermes Italia. All rights reserved.
//

#ifndef template_HTTP_h
#define template_HTTP_h

//
//  HTTP.h
//
//#import <Cocoa/Cocoa.h>

typedef void (^httpHandlePtr)(NSString *dataStr);

@protocol HTTPDelegate


@required
- (void)didFinishDownload:(NSString *)dataStr;
- (void)didFail:(NSString *)failedMessage;

@end

@interface HTTP : NSObject {
    id delegate;
    NSMutableData *receivedData;
    NSURL *url;
}
@property (nonatomic,retain) NSMutableData *receivedData;
@property (retain) id delegate;
@property (nonatomic,retain) httpHandlePtr httpHandle;


- (void)get: (NSString *)urlString;
- (void)get: (NSString *)urlString withHandle:(httpHandlePtr)handle;
- (void)post: (NSString *)urlString withParams:(NSDictionary*)bodyParameters;

@end

#endif
