//
//  LoginViewController.m
//  template
//
//  Created by Andrea della Porta on 19/08/15.
//  Copyright (c) 2015 Ermes Italia. All rights reserved.
//

#import "LoginViewController.h"
#import "CustomData.h"
#import "AppDelegate.h"
#import "ChatViewController.h"
#import "ViewController.h"
#import "NotifiesListViewController.h"


#define ENABLE_LOG YES

@interface LoginViewController ()

@property NSArray *constraint_POS_V;
@property NSDictionary *viewsDictionary;

@property (weak, nonatomic) IBOutlet UISegmentedControl *toggler;

@property (weak, nonatomic) IBOutlet UILabel *pwdConfirmLabel;
@property (weak, nonatomic) IBOutlet UILabel *pwdLabel;
@property (weak, nonatomic) IBOutlet UITextField *pwdConfirmText;
@property (weak, nonatomic) IBOutlet UILabel *nameLabel;
@property (weak, nonatomic) IBOutlet UITextField *nameText;
@property (weak, nonatomic) IBOutlet UILabel *lastnameLabel;
@property (weak, nonatomic) IBOutlet UITextField *lastnameText;
@property (weak, nonatomic) IBOutlet UILabel *phoneLabel;
@property (weak, nonatomic) IBOutlet UITextField *phoneText;
@property (weak, nonatomic) IBOutlet UILabel *emailLabel;
@property (weak, nonatomic) IBOutlet UITextField *emailText;
@property (weak, nonatomic) IBOutlet UITextField *pwdText;
@property (weak, nonatomic) IBOutlet UILabel *countryLabel;
@property (weak, nonatomic) IBOutlet UITextField *countryText;
@property (weak, nonatomic) IBOutlet UILabel *cityLabel;
@property (weak, nonatomic) IBOutlet UITextField *cityText;
@property (weak, nonatomic) IBOutlet UILabel *companyLabel;
@property (weak, nonatomic) IBOutlet UITextField *companyText;
@property (weak, nonatomic) IBOutlet UILabel *occupationLabel;
@property (weak, nonatomic) IBOutlet UITextField *occupationText;
@property (weak, nonatomic) IBOutlet UILabel *businessLabel;
@property (weak, nonatomic) IBOutlet UITextField *businessText;
@property (weak, nonatomic) IBOutlet UILabel *birthLabel;
@property (weak, nonatomic) IBOutlet UIDatePicker *birthText;
@property (weak, nonatomic) IBOutlet UILabel *sexLabel;
@property (weak, nonatomic) IBOutlet UISegmentedControl *sexToggler;
@property (weak, nonatomic) IBOutlet UIScrollView *scrollView;
@property (weak, nonatomic) IBOutlet UIButton *backButton;
@property (weak, nonatomic) IBOutlet UILabel *authLabel;
@property (weak, nonatomic) IBOutlet UITextField *authText;
@property (weak, nonatomic) IBOutlet UILabel *mandatoryLabel;
@property (weak, nonatomic) IBOutlet UIButton *privacyButton;
@property (weak, nonatomic) IBOutlet UIButton *registerButton;
@property (weak, nonatomic) IBOutlet UIView *signupContentView;
@property (weak, nonatomic) IBOutlet UIView *mainContentView;
@property UITextField *loginEmailText;
@property UITextField *loginPwdText;
@property UIView *loginContentView;
@property UIButton *loginButton;
@property UILabel *loginEmailLabel;
@property UILabel *loginPwdLabel;
@property (weak, nonatomic) IBOutlet UIView *grandContentView;
@property (weak, nonatomic) IBOutlet UIView *mainCanvas;

@end

UIAlertView *privacyAlert;
static BOOL isRegistered;
static BOOL isLoggedIn;
static NSString *code;
NSString *pwdToBeSaved;
BOOL shouldGoToHomepage;
UITextField *activeField;
UITapGestureRecognizer *tap;

@implementation LoginViewController

+ (NSString*)codeGet
{
    return code;
}

+ (void)codeSet:(NSString*)reg
{
    code = reg;
    NSLog(@"GOT CODE: %@", code);
}

+ (BOOL)loggedInGet
{
    return isLoggedIn;
}

+ (void)loggedInSet:(bool)reg
{
    isLoggedIn = reg;
    if(isLoggedIn)
        [[NSNotificationCenter defaultCenter] postNotificationName:@"hasBeenLoggedIn" object:nil userInfo:nil];
}

+ (BOOL)registerGet
{
    return isRegistered;
}

+ (void)registerSet:(bool)reg
{
    isRegistered = reg;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    self.loginContentView = nil;
    
    [self registerForKeyboardNotifications];
    
    tap = [[UITapGestureRecognizer alloc] initWithTarget:self
                                                                          action:@selector(dismissKeyboard)];
    //tap.cancelsTouchesInView = NO;
    
    self.toggler.selectedSegmentIndex = 1;
    
    if([LoginViewController registerGet] && ![LoginViewController loggedInGet])
        [self Login:[ChatViewController usernameGet] withPwd:[ChatViewController pwdGet] shouldGoToHomepage:YES];

    if(PUSHER_USE_REGISTRATION)
        self.backButton.hidden = YES;
    else self.backButton.hidden = NO;
    
    self.authLabel.hidden = self.authText.hidden = !AUTHENTICATED_REGISTRATION;
    
#if false
    self.loginButton.layer.cornerRadius = 4;
    self.loginButton.layer.borderWidth = 2;
    self.loginButton.layer.borderColor = [UIColor blueColor].CGColor;
#endif
    
    [self toggleLanguage];
}

-(void)setTextFieldAppearance:(UITextField*)text
{
    text.backgroundColor = [UIColor whiteColor];
    text.textAlignment = UITextAlignmentLeft;
    //[text setBorderStyle:UITextBorderStyleRoundRect];
    [text.layer setBorderColor:[UIColor lightGrayColor].CGColor];
    [text.layer setBorderWidth:0.5f];
    [text.layer setCornerRadius:5.0f];
    UIView *spacerView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 5, 5)];
    [text setLeftViewMode:UITextFieldViewModeAlways];
    [text setLeftView:spacerView];
}

-(UILabel*)createLabel:(UIView*)contentView
{
    UILabel *label = [[UILabel alloc] init];
    label.textAlignment = NSTextAlignmentRight;
    [contentView addSubview:label];
    [label setTranslatesAutoresizingMaskIntoConstraints:NO];
    
    return label;
}

-(UITextField*)createTextField:(UIView*)contentView
{
    UITextField *text = [[UITextField alloc] init];
    [contentView addSubview:text];
    [text setTranslatesAutoresizingMaskIntoConstraints:NO];
    [self setTextFieldAppearance:text];
    
    return text;
}

-(NSDictionary*)createMetrics
{
    int spacing = 20, spacingH = 10, spacingHT = 45;
    int y = spacing;
    int lw = self.view.frame.size.width * 0.32f - spacingH;
    int tw = self.view.frame.size.width * 0.68f - spacingHT;
    int bw = self.view.frame.size.width * 0.3f;
    int h = self.view.frame.size.height*0.05f;
    int lx = 20;
    int tx = lx + lw + 20;
    
    NSDictionary* metrics = @{@"tw":[NSNumber numberWithInt:tw], @"lw":[NSNumber numberWithInt:lw], @"spacing":[NSNumber numberWithInt:spacing], @"spacingH":[NSNumber numberWithInt:spacingH], @"spacingHT":[NSNumber numberWithInt:spacingHT], @"h":[NSNumber numberWithInt:h], @"buttonW":[NSNumber numberWithInt:bw]};
    
    return metrics;
}

-(void)createLoginPanel
{
    self.loginContentView = [[UIView alloc] init];//initWithFrame:CGRectMake(0, 0, scrollView.frame.size.width, scrollView.frame.size.height)];
    [self.grandContentView addSubview:self.loginContentView];
    self.loginContentView.translatesAutoresizingMaskIntoConstraints = NO;
    
    NSDictionary* metrics = [self createMetrics];
    
    self.loginEmailLabel = [self createLabel:self.loginContentView];
    self.loginEmailText = [self createTextField:self.loginContentView];
    [self.loginEmailText setKeyboardType:UIKeyboardTypeEmailAddress];
    
    self.loginPwdLabel = [self createLabel:self.loginContentView];
    self.loginPwdText = [self createTextField:self.loginContentView];
    [self.loginPwdText setKeyboardType:UIKeyboardTypeDefault];
    [self.loginPwdText setSecureTextEntry:YES];
    
    self.loginButton = [[UIButton alloc] init];
    [self.loginContentView addSubview:self.loginButton];
    [self.loginButton setTranslatesAutoresizingMaskIntoConstraints:NO];
    [self.loginButton addTarget:self action:@selector(doLogin:) forControlEvents:UIControlEventTouchUpInside];
    [self.loginButton setTitleColor:self.view.tintColor forState:UIControlStateNormal];
    UIView *spacer1 = [[UIView alloc] init];
    UIView *spacer2 = [[UIView alloc] init];
    spacer1.translatesAutoresizingMaskIntoConstraints = NO;
    spacer2.translatesAutoresizingMaskIntoConstraints = NO;
    [self.loginContentView addSubview:spacer1];
    [self.loginContentView addSubview:spacer2];
    
    NSDictionary* viewDict = @{@"loginContentView":self.loginContentView, @"grandContentView":self.grandContentView, @"loginEmailText":self.loginEmailText, @"loginEmailLabel":self.loginEmailLabel, @"loginPwdText":self.loginPwdText, @"loginPwdLabel":self.loginPwdLabel , @"loginButton":self.loginButton, @"spacer1":spacer1, @"spacer2":spacer2};
    
    [self.grandContentView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:|[loginContentView]|" options:0 metrics:0 views:viewDict]];
    [self.grandContentView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"V:|[loginContentView]|" options:0 metrics:0 views:viewDict]];
    //[grandContentView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:[loginContentView(==mainView)]" options:0 metrics:0 views:viewDict]];
    
    [self.loginContentView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:|[loginEmailLabel(lw)]-spacingH-[loginEmailText]-spacingHT-|" options:0 metrics:metrics views:viewDict]];
    [self.loginContentView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:|[loginPwdLabel(lw)]-spacingH-[loginPwdText]-spacingHT-|" options:0 metrics:metrics views:viewDict]];
    
    [self.loginContentView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:|[spacer1][loginButton(buttonW)][spacer2(==spacer1)]|" options:0 metrics:metrics views:viewDict]];

    [self.loginContentView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"V:|-spacing-[loginEmailLabel(h)]-spacing-[loginPwdLabel(h)]-spacing-[loginButton(h)]" options:0 metrics:metrics views:viewDict]];
    [self.loginContentView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"V:|-spacing-[loginEmailText(h)]-spacing-[loginPwdText(h)]-spacing-[loginButton(h)]" options:0 metrics:metrics views:viewDict]];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)toggleLanguage
{
    NSString *table = [ViewController getLanguageSelected];
    
    self.loginEmailLabel.text = NSLocalizedStringFromTable(@"login email", table, nil);
    self.loginPwdLabel.text = NSLocalizedStringFromTable(@"login pwd", table, nil);
    self.emailLabel.text = NSLocalizedStringFromTable(@"login email", table, nil);
    self.pwdLabel.text = NSLocalizedStringFromTable(@"login pwd", table, nil);
    self.pwdConfirmLabel.text = NSLocalizedStringFromTable(@"login pwd conferma", table, nil);
    self.nameLabel.text = NSLocalizedStringFromTable(@"login nome", table, nil);
    self.lastnameLabel.text = NSLocalizedStringFromTable(@"login cognome", table, nil);
    self.phoneLabel.text = NSLocalizedStringFromTable(@"login telefono", table, nil);
    self.countryLabel.text = NSLocalizedStringFromTable(@"login paese", table, nil);
    self.cityLabel.text = NSLocalizedStringFromTable(@"login citta", table, nil);
    self.companyLabel.text = NSLocalizedStringFromTable(@"login societa", table, nil);
    self.occupationLabel.text = NSLocalizedStringFromTable(@"login occupazione", table, nil);
    self.businessLabel.text = NSLocalizedStringFromTable(@"login professione", table, nil);
    self.birthLabel.text = NSLocalizedStringFromTable(@"login data nascita", table, nil);
    self.sexLabel.text = NSLocalizedStringFromTable(@"login sesso", table, nil);
    self.authLabel.text = NSLocalizedStringFromTable(@"login auth", table, nil);
    self.mandatoryLabel.text = NSLocalizedStringFromTable(@"login obbligatorio", table, nil);
    [self.privacyButton setTitle:NSLocalizedStringFromTable(@"leggi informativa privacy", table, nil) forState:UIControlStateNormal];
    [self.loginButton setTitle:@"Login" forState:UIControlStateNormal];
}

- (void)registerForKeyboardNotifications
{
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(keyboardWasShown:)
                                                 name:UIKeyboardDidShowNotification object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(keyboardWillBeHidden:)
                                                 name:UIKeyboardWillHideNotification object:nil];
}

- (void)viewDidAppear:(BOOL)animated
{
    if(!self.loginContentView)
        [self createLoginPanel];
    [self toggleState:self.toggler.selectedSegmentIndex];
    
    self.emailText.delegate =
    self.pwdText.delegate =
    self.pwdConfirmText.delegate =
    self.nameText.delegate =
    self.lastnameText.delegate =
    self.phoneText.delegate =
    self.countryText.delegate =
    self.cityText.delegate =
    self.companyText.delegate =
    self.occupationText.delegate =
    self.businessText.delegate =
    self.authText.delegate =
    self.loginEmailText.delegate =
    self.loginPwdText.delegate = self;

    [self toggleLanguage];

    [self adjustContentSize];
}

- (void)dealloc
{
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

-(void)adjustContentSize
{
#if false
    //self.scrollView.translatesAutoresizingMaskIntoConstraints  = NO;
    //self.contentview.translatesAutoresizingMaskIntoConstraints  = NO;
    
    int num;
    if(self.toggler.selectedSegmentIndex == 0)
        num = 3;
    else if(AUTHENTICATED_REGISTRATION)
        num = 16;
    else num = 15+1;
    
    float h = (self.view.frame.size.height*0.06 + 20)*num;
#if false
    [self.scrollView setContentSize:CGSizeMake(self.view.frame.size.width, h)];
    [self.mainContentView setFrame:CGRectMake(0, 0, self.view.frame.size.width, h)];
    [self.mainContentView setBounds:CGRectMake(0, 0, self.view.frame.size.width, h)];
#endif
#endif
}

- (void)textFieldDidBeginEditing:(UITextField *)textField
{
    activeField = textField;
}

- (void)textFieldDidEndEditing:(UITextField *)textField
{
}

- (IBAction)doReadPrivacy:(id)sender
{
    UIAlertView *alertView = [[UIAlertView alloc]initWithTitle:@"Privacy" message:NSLocalizedStringFromTable(@"informativa privacy", [ViewController getLanguageSelected], nil) delegate:nil cancelButtonTitle:NSLocalizedStringFromTable(@"OK", [ViewController getLanguageSelected], nil) otherButtonTitles:nil];
    [alertView show];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    /*alertView = [[UIAlertView alloc] initWithTitle:@"TextField Should Return Method Called!" message:nil delegate:self cancelButtonTitle:@"Ok" otherButtonTitles:nil];
     [alertView show];*/
    
    [textField resignFirstResponder];
    
    activeField = nil;
    
    return YES;
}

#define REPOSITION_TEXTFIELD  yes

// Called when the UIKeyboardDidShowNotification is sent.
- (void)keyboardWasShown:(NSNotification*)aNotification
{
#ifdef REPOSITION_TEXTFIELD
    if(self.toggler.selectedSegmentIndex == 0)
        return;
    
    NSDictionary* info = [aNotification userInfo];
    CGSize kbSize = [[info objectForKey:UIKeyboardFrameBeginUserInfoKey] CGRectValue].size;
    
#if true
    UIEdgeInsets contentInsets = UIEdgeInsetsMake(0.0, 0.0, kbSize.height, 0.0);
    self.scrollView.contentInset = contentInsets;
    self.scrollView.scrollIndicatorInsets = contentInsets;
    
    // If active text field is hidden by keyboard, scroll it so it's visible
    // Your app might not need or want this behavior.
    CGRect aRect = self.scrollView.frame;//self.view.frame;
    aRect.size.height -= kbSize.height;
    if (!CGRectContainsPoint(aRect, activeField.frame.origin) ) {
        [self.scrollView scrollRectToVisible:activeField.frame animated:NO];
    }
#else
    oldActiveYoffset = self.view.frame.size.height - self.view.frame.size.width*TEXT_VIEW_HEIGHT_MULT;//activeField.frame.origin.y;
    activeField.frame = CGRectMake(activeField.frame.origin.x, oldActiveYoffset-kbSize.height, activeField.frame.size.width, activeField.frame.size.height);
#endif
#endif
}

// Called when the UIKeyboardWillHideNotification is sent
- (void)keyboardWillBeHidden:(NSNotification*)aNotification
{
#ifdef REPOSITION_TEXTFIELD
#if true
    UIEdgeInsets contentInsets = UIEdgeInsetsZero;
    self.scrollView.contentInset = contentInsets;
    self.scrollView.scrollIndicatorInsets = contentInsets;
#else
    activeField.frame = CGRectMake(activeField.frame.origin.x, oldActiveYoffset, activeField.frame.size.width, activeField.frame.size.height);
#endif
#endif
}

-(void)textViewDidEndEditing:(UITextView *)textView{
    //NSLog(@"Did End editing");
    [textView resignFirstResponder];
    activeField = nil;
}

- (void)toggleState:(NSInteger)state
{
    [self dismissKeyboard];
    
    if(state == 0)
    {
#if false
        self.pwdConfirmLabel.hidden =
        self.pwdConfirmText.hidden =
        self.nameLabel.hidden =
        self.nameText.hidden =
        self.lastnameLabel.hidden =
        self.lastnameText.hidden =
        self.phoneLabel.hidden =
        self.phoneText.hidden =
        self.countryText.hidden =
        self.cityText.hidden =
        self.companyText.hidden =
        self.occupationText.hidden =
        self.businessText.hidden =
        self.birthText.hidden =
        self.sexToggler.hidden =
        self.countryLabel.hidden =
        self.cityLabel.hidden =
        self.companyLabel.hidden =
        self.occupationLabel.hidden =
        self.businessLabel.hidden =
        self.birthLabel.hidden =
        self.sexLabel.hidden =
        self.authLabel.hidden =
        self.authText.hidden = YES;
        
        if(self.constraint_POS_V != nil)
            [self.contentview removeConstraints:self.constraint_POS_V];
        self.constraint_POS_V = [NSLayoutConstraint constraintsWithVisualFormat:@"V:[pwdText]-20-[loginButton]-20-|"
                                                                        options:0
                                                                        metrics:nil
                                                                          views:self.viewsDictionary];
        [self.contentview addConstraints:self.constraint_POS_V];
#else
        //[self.mainContentView bringSubviewToFront:self.loginContentView];
        self.grandContentView.hidden = NO;//aka login
        self.mainContentView.hidden = YES;//aka signup
        
        [self.mainCanvas bringSubviewToFront:self.grandContentView];
        [self.grandContentView addGestureRecognizer:tap];
        
        //self.scrollView.scrollEnabled = NO;
#endif
    }
    else
    {
#if false
        self.pwdConfirmLabel.hidden =
        self.pwdConfirmText.hidden =
        self.nameLabel.hidden =
        self.nameText.hidden =
        self.lastnameLabel.hidden =
        self.lastnameText.hidden =
        self.phoneLabel.hidden =
        self.phoneText.hidden =
        self.countryText.hidden =
        self.cityText.hidden =
        self.companyText.hidden =
        self.occupationText.hidden =
        self.businessText.hidden =
        self.birthText.hidden =
        self.sexToggler.hidden =
        self.countryLabel.hidden =
        self.cityLabel.hidden =
        self.companyLabel.hidden =
        self.occupationLabel.hidden =
        self.businessLabel.hidden =
        self.birthLabel.hidden =
        self.sexLabel.hidden = NO;
        
        if(self.constraint_POS_V != nil)
            [self.contentview removeConstraints:self.constraint_POS_V];
        if(AUTHENTICATED_REGISTRATION)
        {
            self.authLabel.hidden =
            self.authText.hidden = NO;
            self.constraint_POS_V = [NSLayoutConstraint constraintsWithVisualFormat:@"V:[authText]-20-[loginButton]-20-|"
                                                                            options:0
                                                                            metrics:nil
                                                                              views:self.viewsDictionary];
        }
        else
        {
            self.authLabel.hidden =
            self.authText.hidden = YES;
            self.constraint_POS_V = [NSLayoutConstraint constraintsWithVisualFormat:@"V:[sexToggler]-20-[loginButton]-20-|"
                                                                        options:0
                                                                        metrics:nil
                                                                          views:self.viewsDictionary];
        }
        
        [self.contentview addConstraints:self.constraint_POS_V];
#else
        if(AUTHENTICATED_REGISTRATION)
        {
            self.authLabel.hidden =
            self.authText.hidden = NO;
        }
        else
        {
            self.authLabel.hidden =
            self.authText.hidden = YES;
        }
        
        //[self.mainContentView bringSubviewToFront:self.signupContentView];
        self.grandContentView.hidden = YES; //aka login
        self.mainContentView.hidden = NO;   //aka signup
        
        [self.mainCanvas bringSubviewToFront:self.self.scrollView];
        [self.scrollView addGestureRecognizer:tap];
        
        //self.scrollView.scrollEnabled = YES;
#endif
    }
    
    [self.scrollView setContentOffset:CGPointMake(0, 0)];
}

- (void) viewDidLayoutSubviews
{
    [self adjustContentSize];
}

- (IBAction)togglerChanged:(id)sender
{
    UISegmentedControl *s = (UISegmentedControl *)sender;
    
    [self toggleState:s.selectedSegmentIndex];
}

- (void)Login:(NSString*)email withPwd:(NSString*)pwd shouldGoToHomepage:(BOOL)homepage
{
    AppDelegate *delegate = [UIApplication sharedApplication].delegate;
    
    if(ENABLE_LOG) NSLog(@"LOGGING IN: username:%@ pwd:%@ token:%@", email, pwd, (!delegate.token_string)?@"NULL-TOKEN":delegate.token_string);
    
    pwdToBeSaved = pwd;
    shouldGoToHomepage = homepage;
    
    //login
    NSDictionary* bodyParameters = @{
                                     @"email": email,
                                     @"password": pwd,
                                     @"platform_code": PLATFORM_CODE,
                                     @"company_code": CODE,
#ifdef IBATEST
                                     @"device_token": TEST_TOKEN
#else
                                     @"device_token": ((!delegate.token_string)?@"unregistered":delegate.token_string)
#endif
                                     };
    
    //if([InfoPageViewController checkConnectivity])
    {
        HTTP *http = [[HTTP alloc] init];
        http.delegate = self;
        
        [http post:LOGIN_URL withParams:bodyParameters];
    }
}

- (IBAction)doLogin:(id)sender
{
    AppDelegate *delegate = [UIApplication sharedApplication].delegate;
 
    if(self.toggler.selectedSegmentIndex == 0)
    {
        [self Login:self.loginEmailText.text withPwd:self.loginPwdText.text shouldGoToHomepage:YES];
    }
    else
    {
        //signup
        privacyAlert = [[UIAlertView alloc]initWithTitle:@"Privacy" message:NSLocalizedStringFromTable(@"informativa privacy", [ViewController getLanguageSelected], nil) delegate:self cancelButtonTitle:NSLocalizedStringFromTable(@"Esci", [ViewController getLanguageSelected], nil) otherButtonTitles:NSLocalizedStringFromTable(@"signup accetta", [ViewController getLanguageSelected], nil), nil];
        [privacyAlert show];
    }
}

-(void)signup
{
    AppDelegate *delegate = [UIApplication sharedApplication].delegate;

    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"dd/MM/yyyy"];
    NSString *formattedDate = [dateFormatter stringFromDate:self.birthText.date];
    
    pwdToBeSaved = self.pwdText.text;
    shouldGoToHomepage = YES;
    
    NSDictionary* bodyParameters = @{
                                     @"name": self.nameText.text,
                                     @"last_name": self.lastnameText.text,
                                     @"email": self.emailText.text,
                                     @"phone": self.phoneText.text,
                                     @"password": self.pwdText.text,
                                     @"password_confirmation": self.pwdConfirmText.text,
                                     @"country": self.countryText.text,
                                     @"city": self.cityText.text,
                                     @"company": self.companyText.text,
                                     @"occupation": self.occupationText.text,
                                     @"business_area": self.businessText.text,
                                     @"year_of_birth": formattedDate,
                                     @"sex": (self.sexToggler.selectedSegmentIndex == 0?@"M":@"F"),
                                     @"platform_code": PLATFORM_CODE,
                                     @"company_code": CODE,
                                     @"activation_code": AUTHENTICATED_REGISTRATION?self.authText.text:@"",
#ifdef IBATEST
                                     @"device_token": TEST_TOKEN
#else
                                     @"device_token": delegate.token_string
#endif
                                     };
    
    HTTP *http = [[HTTP alloc] init];
    http.delegate = self;
    [http post:SIGNUP_URL withParams:bodyParameters];
}

- (void)didFinishDownload:(NSString *)data
{
    NSDictionary* contentArray;
    NSError* error;
    NSData *encData = [data dataUsingEncoding:NSUTF8StringEncoding];
    contentArray = [NSJSONSerialization JSONObjectWithData:encData options:kNilOptions error:&error];
    if (error != nil)
    {
        NSLog(@"%@", [error localizedDescription]);
        return;
    }
    
    if(contentArray != nil)
    {
        /*for(NSDictionary *itemArray in contentArray)
        {
        }*/
        
        if([contentArray objectForKey:@"errors"])
        {
            NSLog(@"An error occurred");
            NSString *errorStr = @"Unknown Error";
#if true
            NSDictionary* itemArray = [contentArray objectForKey:@"errors"];
            if(itemArray != nil && [itemArray count] > 0)
            {
                NSString *key = [[itemArray allKeys] objectAtIndex:0];
                NSString *str = [[itemArray objectForKey:key] objectAtIndex:0];
                errorStr = str;
            }
            
            UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Error!" message:errorStr delegate:self cancelButtonTitle:@"Ok" otherButtonTitles:nil];
            [alertView show];
#endif
            return;
        }
        else
        {
            NSDictionary* itemArray = [contentArray objectForKey:@"user"];
            
            NSString *email = [itemArray objectForKey:@"email"];
            [LoginViewController codeSet:[itemArray objectForKey:@"code"]];
            [ChatViewController usernameSet:email];
            NSString *pwd = pwdToBeSaved;
            [ChatViewController pwdSet:pwd];
            
            [LoginViewController registerSet:YES];
            [LoginViewController loggedInSet:YES];
            
            if(ENABLE_LOG)  NSLog(@"-------->  Setting loggedIn to TRUE");
            
            NSString *plistPath;
            NSString *error;
            NSString *rootPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
            
            //NSData *plistXML;
            rootPath = [rootPath stringByAppendingPathComponent:@"data.plist"];
            if (![[NSFileManager defaultManager] fileExistsAtPath:rootPath]) {
                plistPath = [[NSBundle mainBundle] pathForResource:@"data" ofType:@"plist"];
                //plistXML = [[NSFileManager defaultManager] contentsAtPath:plistPath];
            }
            //else plistXML = [[NSFileManager defaultManager] contentsAtPath:rootPath];

            NSDictionary *plistDict = [NSDictionary dictionaryWithObjects:
                                       [NSArray arrayWithObjects: email, pwd, [NSNumber numberWithBool:YES], [NSNumber numberWithBool:NO], nil]
                                                                  forKeys:[NSArray arrayWithObjects: @"username", @"pwd", @"isRegistered", @"dismiss", nil]];
            NSData *plistData = [NSPropertyListSerialization dataFromPropertyList:plistDict
                                                                           format:NSPropertyListXMLFormat_v1_0
                                                                 errorDescription:&error];
            if(plistData) {
                [plistData writeToFile:rootPath atomically:YES];
            }
            else {
                NSLog(error);
                //[error release];
            }
            
            if(shouldGoToHomepage)
                [self performSegueWithIdentifier:@"showHomepageSegue" sender:self];
            else
            {
                UIViewController *uivc = [ViewController visibleViewController];
                if(uivc && [uivc isKindOfClass:[ViewController class]])
                {
                    ViewController *vc = (ViewController*)uivc;
                    if(vc.innerViewController)
                    {
                        [vc.innerViewController actionrefresh:nil];
                    }
                }
            }
        }
    }
}

-(void)dismissKeyboard
{
    if(activeField)
        [activeField resignFirstResponder];
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if (buttonIndex == 0)
    {
        if(alertView == privacyAlert)
        {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Info" message:NSLocalizedStringFromTable(@"devi accettare", [ViewController getLanguageSelected], nil) delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil];
            [alert show];
        }
    }
    if (buttonIndex == 1)
    {
        [self signup];
    }
}

- (void)didFail:(NSString *)failedMessage {}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
