//
//  NotifiesListViewController.h
//
//
//  Created by Andrea della Porta on 12/03/15.
//  Copyright (c) 2015 Ermes Italia. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ViewController.h"
#import "HTTP.h"
#import "NotifyItem.h"

@interface NotifiesListViewController : UIViewController<UITableViewDelegate, UITableViewDataSource, HTTPDelegate>

+(UIImage *) getImageFromURL:(NSString *)fileURL;
+(void) saveImage:(UIImage *)image withFileName:(NSString *)imageName inDirectory:(NSString *)directoryPath;
+(UIImage *) loadImage:(NSString *)fileName inDirectory:(NSString *)directoryPath;
+(void) writeToTextFile:(NSString*)filename andData:(NSString*)data;
+(NSString *) readFromTextFile:(NSString*)name;
+(NSArray *) findFiles:(NSString*)dir withExtension:(NSString*)extension;
+(void) removeFile:(NSString*)filename;
- (IBAction)unwindToNotifiesList:(UIStoryboardSegue *)segue;
- (IBAction)actionrefresh:(id)sender;
@property (weak, nonatomic) IBOutlet UIActivityIndicatorView *activityIndicator;
@property (weak, nonatomic) IBOutlet UITableView *notifyTable;
@property NSMutableArray *notifyList;
+(int)populate:(NSString*)data onList:(NSMutableArray *)list;
@property (weak, nonatomic) IBOutlet UIView *myView;
+ (void) resetBadge;
- (void)refreshList:(NSMutableArray *)list initPopulation:(BOOL)initWithPopulation jumpToEvent:(NSString*)eventCode;

@property BOOL isEmbedded;
@property ViewController *parentController;
@property NSString* jumpToEvent;
@property UIViewController *presenterController;

+ (void)doLoginOrChat:(NotifyItem*)item fromController:(UIViewController*)vc;

@end
