//
//  NotifiesListViewController.m
//
//
//  Created by Andrea della Porta on 12/03/15.
//  Copyright (c) 2015 Ermes Italia. All rights reserved.
//

#import "NotifiesListViewController.h"
#import "LoginViewController.h"
#import "NotifyItem.h"
#import "ThumbViewCell.h"
#import "CustomData.h"
#import "AppDelegate.h"
#import "ChatViewController.h"
#import "InfoPageViewController.h"

#define ENABLE_LOG NO


@interface NotifiesListViewController ()
{
   
}
@property NSURLConnection *site_connection;
@property NSString *downloadedData;
@property UIImage *readImage;
@property UIImage *notReadImage;
@property (weak, nonatomic) IBOutlet UILabel *blackRibbon;
@property (weak, nonatomic) IBOutlet UIButton *backButton;
@property (weak, nonatomic) IBOutlet UIButton *refreshButton;
@property (weak, nonatomic) IBOutlet UIButton *chatButton;
@property (weak, nonatomic) IBOutlet UILabel *logoRibbon;
@property (weak, nonatomic) IBOutlet UIImageView *logo;
@property NSDictionary *viewsDictionary;
@property NSArray *constraint_POS_V;
@property (weak, nonatomic) IBOutlet UIImageView *logoBackground;
@property (weak, nonatomic) IBOutlet UIView *spacer;
@property (weak, nonatomic) IBOutlet UIView *ribbonSpacer;
@property (weak, nonatomic) IBOutlet UIButton *mosaicButton;

@property UIImage *chatImg;
@property UIImage *chatNewImg;
@property NSInteger globalMsgNo;

@end

#define ROW_HEIGHT(x, view) (self.isEmbedded?(((NotifyItem*)[self.notifyList objectAtIndex:x]).image?((view).bounds.size.height*0.25):((view).bounds.size.height*0.16)):((view).bounds.size.height*0.12))

@implementation NotifiesListViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view.

    self.chatNewImg = [UIImage imageNamed:@"chat_new.png"];
    self.chatImg = [UIImage imageNamed:@"chat.png"];
    
    [self.logoRibbon setBackgroundColor:LOGO_BACK_COLOR];
    
    self.readImage = [UIImage imageNamed:@"read.png"];
    self.notReadImage = [UIImage imageNamed:@"notRead.png"];
    
    self.notifyList = [[NSMutableArray alloc] init];
    
    [self refreshList:self.notifyList initPopulation:YES jumpToEvent:self.jumpToEvent];
    
    self.viewsDictionary = @{@"logo":self.logo, @"notifyTable":self.notifyTable, @"myView":self.myView, @"spacer":self.spacer, @"blackRibbon":self.blackRibbon, @"ribbonSpacer":self.ribbonSpacer};
    
    if(self.constraint_POS_V != nil)
        [self.myView removeConstraints:self.constraint_POS_V];
    if(self.isEmbedded)
    {
        self.blackRibbon.hidden = self.backButton.hidden = self.refreshButton.hidden = self.chatButton.hidden = self.mosaicButton.hidden = self.logoRibbon.hidden = self.logo.hidden = self.logoBackground.hidden = YES;
        self.constraint_POS_V = [NSLayoutConstraint constraintsWithVisualFormat:@"V:[spacer(0)]-0-[notifyTable]-0-[blackRibbon(0)]"
                                                                        options:0
                                                                        metrics:nil
                                                                          views:self.viewsDictionary];
        self.notifyTable.scrollEnabled = NO;
        self.blackRibbon.userInteractionEnabled = self.backButton.userInteractionEnabled = self.refreshButton.userInteractionEnabled = self.chatButton.userInteractionEnabled = self.mosaicButton.userInteractionEnabled = NO;
    }
    else
    {
        //NSDictionary *metrics = @{@"brHeight":[NSNumber numberWithInt:68/*(self.myView.frame.size.width*0.15f+4)*/]};
        self.blackRibbon.hidden = self.backButton.hidden = self.refreshButton.hidden = self.chatButton.hidden = self.mosaicButton.hidden = self.logoRibbon.hidden = self.logo.hidden = self.logoBackground.hidden = NO;
        self.constraint_POS_V = [NSLayoutConstraint constraintsWithVisualFormat:@"V:[logo]-0-[notifyTable]-0-[blackRibbon(==ribbonSpacer)]"
                                                                        options:0
                                                                        metrics:nil//metrics
                                                                          views:self.viewsDictionary];
        self.notifyTable.scrollEnabled = YES;
        self.blackRibbon.userInteractionEnabled = self.backButton.userInteractionEnabled = self.refreshButton. userInteractionEnabled = self.chatButton.userInteractionEnabled = self.mosaicButton.userInteractionEnabled = YES;
    }
    [self.myView addConstraints:self.constraint_POS_V];
}

- (IBAction)unwindToNotifiesList:(UIStoryboardSegue *)segue {
}

- (void)viewDidAppear:(BOOL)animated
{
    [self actionrefresh:nil];
}

- (void)viewWillDisappear:(BOOL)animated
{
    //[self refreshList:self.notifyList initPopulation:NO];
}

-(int)listHeight
{
    int h = 0;
    for(int y = 0; y < self.notifyList.count; ++y)
        h += ROW_HEIGHT(y, (self.isEmbedded)?self.parentController.view:self.myView);
        
    return h;
}

- (void)refreshList:(NSMutableArray *)list initPopulation:(BOOL)initWithPopulation
{
    [self refreshList:list initPopulation:initWithPopulation jumpToEvent:nil];
}

- (void)refreshList:(NSMutableArray *)list initPopulation:(BOOL)initWithPopulation jumpToEvent:(NSString*)eventCode
{
    @synchronized(self)
    {
        if(initWithPopulation)
        {
            NSString* content = [NotifiesListViewController readFromTextFile:@"notifica.txt"];
            if(content)
            {
                int globalMsgNo = [NotifiesListViewController populate:content onList:self.notifyList];
                [self.chatButton setImage:(globalMsgNo > 0)?self.chatNewImg:self.chatImg forState:UIControlStateNormal];

                [self.notifyTable reloadData];
                if(self.isEmbedded)
                    [self.parentController refreshContainerHeight:[self listHeight]];
            }
        }

        AppDelegate *delegate = [UIApplication sharedApplication].delegate;
        BOOL shouldConnect = [self checkIfShouldConnect];

        self.jumpToEvent = nil;

        if([InfoPageViewController checkConnectivity])
        {
            if(shouldConnect)
            {
                self.downloadedData = @"";

                self.jumpToEvent = eventCode;

                NSString* strURL = [NSString stringWithFormat:(SERVER_URL "%@"), IS_PREMIUM?@"":[NSString stringWithFormat:@"/%@", delegate.token_string]];
        #if false
                NSURLRequest *site_request = [NSURLRequest requestWithURL:[NSURL URLWithString:strURL]
                                                              cachePolicy:NSURLRequestUseProtocolCachePolicy
                                                                timeoutInterval:10.0];
                self.site_connection = [[NSURLConnection alloc] initWithRequest:site_request delegate:self];
        #else
                HTTP *http = [[HTTP alloc] init];
                http.delegate = self;
                [http get:strURL];
        #endif
                
                [self.activityIndicator startAnimating];
            }
        }
        #if true
        else if(shouldConnect)
        {
            //these are async
            dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_BACKGROUND, 0), ^{
                [NSThread sleepForTimeInterval:5];
                
                dispatch_async(dispatch_get_main_queue(), ^{
                    [self refreshList:list initPopulation:NO jumpToEvent:eventCode];
                });
            });
        }
        #endif
    }
}

- (void)didFinishDownload:(NSString *)data
{
    self.downloadedData = data;
    [self connectionDidFinishLoading:nil];
}

- (void)didFail:(NSString *)failedMessage
{
    //[self.activityIndicator stopAnimating];
}

+(NSArray *)findFiles:(NSString*)dir withExtension:(NSString *)extension
{
    NSMutableArray *matches = [[NSMutableArray alloc]init];
    NSFileManager *fManager = [NSFileManager defaultManager];
    NSString *item;
    NSArray *contents = [fManager contentsOfDirectoryAtPath:dir error:nil];
    
    // >>> this section here adds all files with the chosen extension to an array
    for (item in contents)
    {
        NSString *ext = [item pathExtension];
        if([extension rangeOfString:ext].location != NSNotFound)
        {
            [matches addObject:item];
        }
    }
    
    return matches;
}

- (void)connection:(NSURLConnection *)connection
  didFailWithError:(NSError *)error
{
    /*
    if(self.site_connection != nil)
        self.site_connection = nil;
     */
    [self.activityIndicator stopAnimating];
    
    //TODO: inform the user with alert
    NSLog(@"Connection failed! Error - %@ %@",
          [error localizedDescription],
          [[error userInfo] objectForKey:NSURLErrorFailingURLStringErrorKey]);
    
#if true
    BOOL shouldConnect = [self checkIfShouldConnect];
    
    if(shouldConnect)
    {
        //these are async
        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_BACKGROUND, 0), ^{
            [NSThread sleepForTimeInterval:5];
            
            dispatch_async(dispatch_get_main_queue(), ^{
                [self refreshList:self.notifyList initPopulation:NO];
            });
        });
    }
#endif
}

-(bool)checkIfShouldConnect
{
    AppDelegate *delegate = [UIApplication sharedApplication].delegate;
    BOOL ret = (IS_PREMIUM && [LoginViewController loggedInGet])    ||
        (IS_PREMIUM && ![LoginViewController registerGet] && !PUSHER_USE_REGISTRATION && delegate.token_string)  ||
        (!IS_PREMIUM && delegate.token_string);
    
    if(ENABLE_LOG) NSLog(@"SHOULD CONNECT? %@, loggedIn:%@ registered:%@ token:%@", ret?@"TRUE":@"FALSE", [LoginViewController loggedInGet]?@"TRUE":@"FALSE", [LoginViewController registerGet]?@"TRUE":@"FALSE", (!delegate.token_string)?@"NULL-TOKEN":delegate.token_string);
    
    return ret;
}

-(void)connection:(NSURLConnection *)site_connection didReceiveData:(NSData *)data
{
    self.downloadedData = [self.downloadedData stringByAppendingString:[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding]];
}

- (IBAction)doGlobalChat:(id)sender
{
    [NotifiesListViewController doLoginOrChat:nil fromController:self];
}

+ (void)doLoginOrChat:(NotifyItem*)item fromController:(UIViewController*)vc
{
    if(!PUSHER_USE_REGISTRATION || [ChatViewController usernameGet])
    {
#if true
        UIStoryboard *storyboard = vc.storyboard;
        AppDelegate *delegate = [UIApplication sharedApplication].delegate;
        UIViewController *uivc = [ViewController visibleViewController];
        
        if(IS_PREMIUM)
        {
            ChatViewController *showViewController = [storyboard instantiateViewControllerWithIdentifier:@"ChatViewController"];
        
            showViewController.notifyItem = item;
        
            //[ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
            if(uivc)
                [uivc presentViewController:showViewController animated:YES completion:nil];
            else NSLog(@"VIEWCONTROLLER NULL ---------------");
            //[[self navigationController] pushViewController:showViewController animated:YES];
        }
        else
        {
#if false
            DetailsViewController *showViewController = [storyboard instantiateViewControllerWithIdentifier:@"DetailsViewController"];
            
            showViewController.notifyItem = item;
            showViewController.parentContr = nil;
            showViewController.parentHeight = vc.view.frame.size.height;
            showViewController.parentWidth = vc.view.frame.size.width;
            
            //[ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
            if(uivc)
                [uivc presentViewController:showViewController animated:YES completion:nil];
            else NSLog(@"VIEWCONTROLLER NULL ---------------");
            //[[self navigationController] pushViewController:showViewController animated:YES];
#endif
        }
#else
        [vc performSegueWithIdentifier:@"showChatSegue" sender:self];
#endif
    }
    else [vc performSegueWithIdentifier:@"showLoginSegue" sender:self];
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    [self.activityIndicator stopAnimating];
    
    int globalMsgNo = [NotifiesListViewController populate:self.downloadedData onList:self.notifyList];
    [self.chatButton setImage:(globalMsgNo > 0)?self.chatNewImg:self.chatImg forState:UIControlStateNormal];
    [self.notifyTable reloadData];
    if(self.isEmbedded)
        [self.parentController refreshContainerHeight:[self listHeight]];
    
    if(self.jumpToEvent)
    {
        if(self.jumpToEvent.length == 0)
            [NotifiesListViewController doLoginOrChat:nil fromController:self];
        else
        {
            NotifyItem *found = nil;
            for (NotifyItem *item in self.notifyList) {
                if ([item.eventCode isEqualToString:self.jumpToEvent]) {
                    found = item;
                    break;
                }
            }
            if(found)
                [NotifiesListViewController doLoginOrChat:found fromController:self];
        }
    }
}

- (NSURL*)applicationDataDirectory
{
    NSFileManager* sharedFM = [NSFileManager defaultManager];
    NSArray* possibleURLs = [sharedFM URLsForDirectory:NSApplicationSupportDirectory
                                             inDomains:NSUserDomainMask];
    NSURL* appSupportDir = nil;
    NSURL* appDirectory = nil;
    
    if ([possibleURLs count] >= 1) {
        // Use the first directory (if multiple are returned)
        appSupportDir = [possibleURLs objectAtIndex:0];
    }
    
    // If a valid app support directory exists, add the
    // app's bundle ID to it to specify the final directory.
    if (appSupportDir) {
        NSString* appBundleID = [[NSBundle mainBundle] bundleIdentifier];
        appDirectory = [appSupportDir URLByAppendingPathComponent:appBundleID];
    }
    
    return appDirectory;
}

+ (void) resetBadge
{
    [UIApplication sharedApplication].applicationIconBadgeNumber = 0;
}

+(int)populate:(NSString*)data onList:(NSMutableArray *)list
{
    int globalMsgNo = 0;
    NSDateFormatter *dateFormat;
    dateFormat = [[NSDateFormatter alloc] init];
    //[dateFormat setLocale:[NSLocale currentLocale]];
    [dateFormat setDateFormat:@"dd/MM/yyyy"];
    //[dateFormat setFormatterBehavior:NSDateFormatterBehaviorDefault];
    
    NSString *documentsDirectoryPath;
    
#if true
    documentsDirectoryPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
#else
    if ([[[UIDevice currentDevice] systemVersion] floatValue] >= 8.0)
    {
        documentsDirectoryPath = NSFileManager.DefaultManager.GetUrls(NSSearchPathDirectory.DocumentDirectory, NSSearchPathDomain.User)[0].Path;
    }
    else
    {
        documentsDirectoryPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments); // iOS 7 and earlier
    }
#endif

    [list removeAllObjects];

#if false
    data = @"[\
            {\
                \"company_id\":\"12\",\
                \"title\":\"titolo 3\",\
                \"description\":\"Vai a: http://www.google.com\",\
                \"activated_at\":\"09\/04\/2015\",\
                \"expire_on\":\"25\/04\/2016\",\
                \"contact\":\"Domenico Putignano\",\
                \"email\":\"dome@puti.com\",\
                \"phone\":\"+39123456\",\
                \"event_id\":\"9\",\
                \"is_read\":\"0\",\
                \"image_tag\":\"20150421180801_87800.jpg\"\
            },\
            {\
                \"company_id\":\"12\",\
                \"title\":\"Titolo 2\",\
                \"description\":\"descrizione 2\",\
                \"activated_at\":\"18\/04\/2015\",\
                \"expire_on\":\"25\/04\/2016\",\
                \"contact\":\"Domenico Putignano\",\
                \"email\":\"dome@puti.com\",\
                \"phone\":\"+39123456\",\
                \"event_id\":\"8\",\
                \"is_read\":\"0\",\
                \"image_tag\":\"20150421180719_57692.jpg\"\
            },\
            {\
                \"company_id\":\"12\",\
                \"title\":\"titolo 1\",\
                \"description\":\"descrizione 1\",\
                \"activated_at\":\"09\/04\/2015\",\
                \"expire_on\":\"18\/04\/2015\",\
                \"contact\":\"Domenico Putignano\",\
                \"email\":\"dome@puti.com\",\
                \"phone\":\"+39123456\",\
                \"event_id\":\"7\",\
                \"is_read\":\"0\",\
                \"image_tag\":\"20150421180645_27431.jpg\"\
            }\
            ]";
#endif
    
#if false
    NSArray *contentArray = [data componentsSeparatedByString:@"\r\n"];
#else
    NSDictionary* contentArray;
    NSError* error;
    NSData *encData = [data dataUsingEncoding:NSUTF8StringEncoding];
    contentArray = [NSJSONSerialization JSONObjectWithData:encData options:kNilOptions error:&error];
    if (error != nil)
    {
        NSLog(@"%@", [error localizedDescription]);
        return -1;
    }
#endif
    
    NSDate *now = [NSDate date];
    NSTimeInterval timeOffset = 23 * 60 * 60 + 59 * 60 + 59;    //remove this if offers expires the very same day
    
    if(contentArray != nil)
    {
        if([contentArray isKindOfClass:[NSDictionary class]] && [contentArray objectForKey:@"errors"])
        {
            NSLog(@"An error occurred");
            NSString *errorStr = @"Unknown Error";
#if true
            NSDictionary* itemArray = [contentArray objectForKey:@"errors"];
            if(itemArray != nil && [itemArray count] > 0)
            {
                NSString *key = [[itemArray allKeys] objectAtIndex:0];
                NSString *str = [[itemArray objectForKey:key] objectAtIndex:0];
                errorStr = str;
            }
            
            UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Error!" message:errorStr delegate:self cancelButtonTitle:@"Ok" otherButtonTitles:nil];
            [alertView show];
#endif
            return -1;
        }

        [NotifiesListViewController writeToTextFile:@"notifica.txt" andData:data];
        
        if([contentArray objectForKey:@"newMessages"])
            globalMsgNo = [[contentArray objectForKey:@"newMessages"] intValue];
        if([contentArray objectForKey:@"events"])
        {
            for(NSDictionary *itemArray in [contentArray objectForKey:@"events"])
            {
                //NSArray *itemArray = [line componentsSeparatedByString:@";"];
                NotifyItem *item = [[NotifyItem alloc] init];
              
                item.numeroOfferta = [itemArray objectForKey:@"id"];
                item.locandina = [[itemArray objectForKey:@"image_tag"] length] == 0 ? NO : YES;
                NSString *dateStr = [itemArray objectForKey:@"expire_on"];
                item.email = [itemArray objectForKey:@"email"];
                if(!dateStr || [dateStr length] <= 0)
                    item.data = nil;
                else
                {
                    item.data = [dateFormat dateFromString:dateStr];
                    item.data = [item.data dateByAddingTimeInterval:timeOffset];
                }
                
                NSString *fromDateStr = [itemArray objectForKey:@"activated_at"];
                if(!fromDateStr || [fromDateStr length] <= 0)
                    item.fromData = [NSDate date];
                else item.fromData = [dateFormat dateFromString:fromDateStr];
                
                NSString *imageName = item.imageName = [itemArray objectForKey:@"image_tag"];
                if((!item.data) || [item.data compare:now] != NSOrderedAscending)
                {
                    if(item.data)
                        item.dataStr = [NSString stringWithFormat:@"%@  -  %@", [dateFormat stringFromDate:item.fromData], [dateFormat stringFromDate:item.data]];
                    else item.dataStr = [dateFormat stringFromDate:item.fromData];
                    item.nomeSMS = [itemArray objectForKey:@"contact"];
                    item.numeroSMS = [itemArray objectForKey:@"phone"];
                    //item.UF1 = [itemArray objectForKey:@""];
                    //item.UF2 = [itemArray objectForKey:@""];
                    item.titolo = [itemArray objectForKey:@"title"];
                    item.isRead = [[itemArray objectForKey:@"is_read"] boolValue];
                    item.descrizione = [itemArray objectForKey:@"description"];
                    if([itemArray objectForKey:@"code"])
                        item.eventCode = [itemArray objectForKey:@"code"];
                    if([itemArray objectForKey:@"newMessages"])
                        item.newMessages = [[itemArray objectForKey:@"newMessages"] intValue];
                    else item.eventCode = @"";
                    if(item.locandina)
                    {
                        NSString *urlName = [IMG_URL stringByAppendingString:imageName];
                        UIImage *image = [NotifiesListViewController loadImage:imageName inDirectory:documentsDirectoryPath];
                        if(image)
                            item.image = image;
                        else
                        {
                            item.image = [NotifiesListViewController getImageFromURL:urlName];
                            if(item.image)
                                [NotifiesListViewController saveImage:item.image withFileName:imageName inDirectory:documentsDirectoryPath];
                        }
                    }
                    
                #if false
                    //just for testing
                    item.image =[UIImage imageNamed:@"personal.png"];
                #endif
                    
                    [list addObject:item];
                }
                else if(item.locandina && [imageName length] > 0)
                {
                    NSString *filePath = [documentsDirectoryPath stringByAppendingPathComponent:imageName];
                    //[NotifiesListViewController removeFile:filePath];
                }
            }
        }
    }
    
    NSArray *currentFiles = [NotifiesListViewController findFiles:documentsDirectoryPath withExtension:@".png.jpg.jpeg"];
    NSString *imgFile;
    for (imgFile in currentFiles)
    {
        NotifyItem *nItem;
        BOOL found = NO;
        for(nItem in list)
        {
            if([imgFile isEqualToString:nItem.imageName])
            {
                found = YES;
                break;
            }
        }
        if(!found)
        {
            NSString *filePath = [documentsDirectoryPath stringByAppendingPathComponent:imgFile];
            //[NotifiesListViewController removeFile:filePath];
        }
    }
    
    return globalMsgNo;
}

+(void) removeFile:(NSString*)filename
{
    NSError *error;
    if([[NSFileManager defaultManager] fileExistsAtPath:filename])
    {
        [[NSFileManager defaultManager] removeItemAtPath:filename error:&error];
        if (error)
            NSLog(@"%@", error);
    }
}

+(UIImage *) getImageFromURL:(NSString *)fileURL {
    UIImage * result;
    
    NSData * data = [NSData dataWithContentsOfURL:[NSURL URLWithString:fileURL]];
    result = [UIImage imageWithData:data];
    
    return result;
}

+(void) saveImage:(UIImage *)image withFileName:(NSString *)imageName inDirectory:(NSString *)directoryPath {
    if ([[imageName lowercaseString] hasSuffix:@".png"]) {
        [UIImagePNGRepresentation(image) writeToFile:[directoryPath stringByAppendingPathComponent:[NSString stringWithFormat:@"%@", imageName]] options:NSAtomicWrite error:nil];
    } else if ([[imageName lowercaseString] hasSuffix:@".jpg"] || [[imageName lowercaseString] hasSuffix:@".jpeg"]) {
        [UIImageJPEGRepresentation(image, 1.0) writeToFile:[directoryPath stringByAppendingPathComponent:[NSString stringWithFormat:@"%@", imageName]] options:NSAtomicWrite error:nil];
    } else {
        NSLog(@"Image Save Failed\nExtension: (%@) is not recognized, use (PNG/JPG)", imageName);
    }
}

+(UIImage *) loadImage:(NSString *)fileName inDirectory:(NSString *)directoryPath {
    UIImage * result = [UIImage imageWithContentsOfFile:[NSString stringWithFormat:@"%@/%@", directoryPath, fileName]];
    
    return result;
}

+(void) writeToTextFile:(NSString*)fname andData:(NSString*)data
{
    NSString *fileName;
    
    //get the documents directory:
#if true
    NSArray *paths = NSSearchPathForDirectoriesInDomains
    (NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory = [paths objectAtIndex:0];
    //make a file name to write the data to using the documents directory:
    fileName = [NSString stringWithFormat:@"%@/%@",
                          documentsDirectory, fname];
#else
    if ([[[UIDevice currentDevice] systemVersion] floatValue] >= 8.0)
    {
        var documents = NSFileManager.DefaultManager.GetUrls(NSSearchPathDirectory.DocumentDirectory, NSSearchPathDomain.User)[0].Path;
        fileName = Path.Combine(documents, fname);
    }
    else
    {
        var documents = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments); // iOS 7 and earlier
        fileName = Path.Combine(documents, fname);
    }
#endif
    
    NSError *error = nil;
    //save content to the documents directory
    [data writeToFile:fileName
              atomically:YES
                encoding:NSUTF8StringEncoding
                   error:&error];
    
    if (error)
        NSLog(@"%@", error);
}

//Method retrieves content from documents directory and
//displays it in an alert
+(NSString*) readFromTextFile:(NSString*)name
{
     NSString *fileName;
    
#if true
    //get the documents directory:
    NSArray *paths = NSSearchPathForDirectoriesInDomains
    (NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory = [paths objectAtIndex:0];
    
    //make a file name to write the data to using the documents directory:
    fileName = [NSString stringWithFormat:@"%@/%@",
                          documentsDirectory, name];
#else
    if ([[[UIDevice currentDevice] systemVersion] floatValue] >= 8.0)
    {
        var documents = NSFileManager.DefaultManager.GetUrls(NSSearchPathDirectory.DocumentDirectory, NSSearchPathDomain.User)[0].Path;
        fileName = Path.Combine(documents, fname);
    }
    else
    {
        var documents = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments); // iOS 7 and earlier
        fileName = Path.Combine(documents, fname);
    }
#endif
    
    NSString *data = [[NSString alloc] initWithContentsOfFile:fileName
                                                    usedEncoding:nil
                                                           error:nil];
    return data;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [self.notifyList count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    NotifyItem *item = [self.notifyList objectAtIndex:indexPath.row];
    
    if(!self.isEmbedded)
    {
        static NSString *customTableIdentifier = @"CustomCellView";
    
#if false
        CustomViewCellTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:customTableIdentifier];
    
        if (cell == nil)
        {
            NSArray *nib = [[NSBundle mainBundle] loadNibNamed:customTableIdentifier owner:self options:nil];
            cell = [nib objectAtIndex:0];
            cell.selectionStyle = UITableViewCellSelectionStyleNone;
        }
    
        cell.date.text = item.dataStr;
        cell.title.text = item.titolo;
        if(item.newMessages > 0)
        {
            /*cell.msgNo.backgroundColor = [UIColor redColor];
            cell.msgNo.layer.cornerRadius = cell.msgNo.bounds.size.width/2;
            cell.msgNo.layer.masksToBounds = YES;*/
            cell.msgNo.hidden = cell.msgBkg.hidden = NO;
            cell.msgNo.text = [@(item.newMessages) stringValue];
        }
        else cell.msgNo.hidden = cell.msgBkg.hidden = YES;
        
        [cell.isRead setImage:item.isRead?self.readImage:self.notReadImage];
        
        return cell;
#endif
        return nil;
    }
    else
    {
        static NSString *customTableIdentifier = @"ThumbCellView";
        
        ThumbViewCell *cell = [tableView dequeueReusableCellWithIdentifier:customTableIdentifier];
        
        if (cell == nil)
        {
            NSArray *nib = [[NSBundle mainBundle] loadNibNamed:customTableIdentifier owner:self options:nil];
            cell = [nib objectAtIndex:0];
            [cell.title addObserver:self forKeyPath:@"contentSize" options:(NSKeyValueObservingOptionNew) context:NULL];
            cell.selectionStyle = UITableViewCellSelectionStyleNone;
        
            NSDictionary *dict = @{@"title":cell.title, @"thumb":cell.thumb, @"mainView":cell.mainView};
            if(item.image)
                [cell.mainView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:[thumb]-20-[title]"
                                                                                  options:0
                                                                                  metrics:nil
                                                                                    views:dict]];
            else [cell.mainView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:|-10-[title]"
                                                                                   options:0
                                                                                   metrics:nil
                                                                                     views:dict]];
        }
        cell.title.text = item.titolo;
        cell.data.text = item.dataStr;
        if(item.newMessages > 0)
        {
            /*cell.msgNo.backgroundColor = [UIColor redColor];
             cell.msgNo.layer.cornerRadius = cell.msgNo.bounds.size.width/2;
             cell.msgNo.layer.masksToBounds = YES;*/
            cell.msgNo.hidden = cell.msgBkg.hidden = NO;
            cell.msgNo.text = [@(item.newMessages) stringValue];
        }
        else cell.msgNo.hidden = cell.msgBkg.hidden = YES;
      
        UIImageView *imageView = cell.thumb;
        imageView.layer.backgroundColor=[[UIColor clearColor] CGColor];
        imageView.layer.cornerRadius=imageView.bounds.size.width/2;
        imageView.layer.borderWidth=0;//2.0;
        imageView.layer.masksToBounds = YES;
        imageView.layer.borderColor=[[UIColor clearColor] CGColor];
        cell.thumb.hidden = NO;
        [cell.thumb setImage:item.image];
        
        return cell;
    }
}

-(void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context {
    UITextView *tv = object;
    [self alignTextView:tv];
}

-(void)alignTextView:(UITextView*)tv
{
    //Center vertical alignment
    //CGFloat topCorrect = ([tv bounds].size.height - [tv contentSize].height * [tv zoomScale])/2.0;
    //topCorrect = ( topCorrect < 0.0 ? 0.0 : topCorrect );
    //tv.contentOffset = (CGPoint){.x = 0, .y = -topCorrect};

    //Bottom vertical alignmen
    CGSize contentSize = [tv sizeThatFits:CGSizeMake(tv.frame.size.width, FLT_MAX)];
    CGFloat topCorrect = ([tv bounds].size.height - contentSize.height);
    topCorrect = (topCorrect <0.0 ? 0.0 : topCorrect);
    //tv.contentOffset = (CGPoint){.x = 0, .y = -topCorrect};
    [tv setContentInset:UIEdgeInsetsMake(topCorrect,0,0,0)];
    //[tv removeObserver:self forKeyPath:@"contentSize"];
}

- (void)tableView:(UITableView *)tableView willDisplayCell:(UITableViewCell *)cell forRowAtIndexPath:(NSIndexPath *)indexPath
{
    cell.backgroundColor = tableView.backgroundColor;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    //[tableView deselectRowAtIndexPath:indexPath animated:YES];    //to deselect the row, if your don't like the selection
    
    NotifyItem *item = [self.notifyList objectAtIndex:indexPath.row];

    if(!item.isRead)
    {
        AppDelegate *delegate = [UIApplication sharedApplication].delegate;
        NSString* strURL = [NSString stringWithFormat:IS_PREMIUM?EVENT_PREMIUM_MARKER_URL:EVENT_MARKER_URL, IS_PREMIUM?item.eventCode:item.numeroOfferta, IS_PREMIUM?@"":delegate.token_string];
        strURL=[strURL stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
        NSData *fileData = [NSData dataWithContentsOfURL:[NSURL URLWithString:strURL]];
        
        item.isRead = YES;
        [self.notifyTable reloadData];
    }

    [NotifiesListViewController doLoginOrChat:item fromController:self];
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return ROW_HEIGHT(indexPath.row, (self.isEmbedded)?self.parentController.view:self.myView);
}

- (IBAction)actionrefresh:(id)sender
{
    [self refreshList:self.notifyList initPopulation:NO];
}

- (IBAction)goMosaic:(id)sender {
#if false
    UIStoryboard *storyboard = self.storyboard;
    MosaicViewController *showViewController = [storyboard instantiateViewControllerWithIdentifier:@"MosaicViewController"];
    
#if true
    NSPredicate *pred = [NSPredicate predicateWithFormat:
                              @"locandina == YES"];
    showViewController.notifyList = [self.notifyList filteredArrayUsingPredicate:pred];
#else
    showViewController.notifyList = self.notifyList;
#endif
    
    //[ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
    [self presentViewController:showViewController animated:YES completion:nil];
    //[[self navigationController] pushViewController:showViewController animated:YES];
#endif
}

@end
