//
//  ViewController.m
//
//
//  Created by Andrea della Porta on 09/03/15.
//  Copyright (c) 2015 Ermes Italia. All rights reserved.
//

#import "ViewController.h"
#import "AppDelegate.h"
#import "CustomData.h"
#import "NotifiesListViewController.h"
#import "NotifyItem.h"
#import "ChatViewController.h"
#import "LoginViewController.h"

@interface ViewController ()

@property (weak, nonatomic) IBOutlet NSLayoutConstraint *firstConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *firstConstraintTwo;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *secondConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *thirdConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *fourthConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *secondConstraintTwo;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *thirdConstraintTwo;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *fourthConstraintTwo;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *fifthConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *fifthConstraintTwo;
@property (weak, nonatomic) IBOutlet UITextView *myTextView;
@property (weak, nonatomic) IBOutlet UIView *myView;
@property (weak, nonatomic) IBOutlet UILabel *newsLabel;
@property (weak, nonatomic) IBOutlet UIImageView *logo;
@property (weak, nonatomic) IBOutlet UIView *contentPane;
@property (weak, nonatomic) IBOutlet UIScrollView *scrollView;
@property (weak, nonatomic) IBOutlet UIImageView *personalImage;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *sottotitoloConstraint;
@property (weak, nonatomic) IBOutlet UIView *spacerTop;
@property (weak, nonatomic) IBOutlet UIView *spacerBot;
@property (weak, nonatomic) IBOutlet UILabel *blackribbon;
@property (weak, nonatomic) IBOutlet UIView *newsBack;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *logoWidth;

@property (weak, nonatomic) IBOutlet UIButton *logoutButton;

@property (weak, nonatomic) IBOutlet UIView *language;
@property (weak, nonatomic) IBOutlet UILabel *mansione;
@property (weak, nonatomic) IBOutlet UILabel *nome;

@property NSDictionary *viewsDictionary;
@property NSDictionary *viewsDictionary2;
@property NSString *descContent;
@property int contRangeLoc, contRangeLen;
@property (weak, nonatomic) IBOutlet UILabel *titoloUno;
@property (weak, nonatomic) IBOutlet UILabel *sottotitolo;

@property (weak, nonatomic) IBOutlet UIView *containerView;
@property NSArray *constraint_H;

@property UIImage *loginImage;
@property UIImage *logoutImage;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *ribbonWidth;

@property NSString *notifiedEventCode;

@end

CGFloat outSize;
static BOOL dismiss;

@implementation ViewController

static int languageSelected = 0;

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    //[setPresentationStyleForSelfController ];
    
    [self.blackribbon setBackgroundColor:LOGO_BACK_COLOR];
    
    self.loginImage = [UIImage imageNamed:@"login-icon.png"];
    self.logoutImage = [UIImage imageNamed:@"logout-icon.png"];
    
    NSNotificationCenter* notifCenter = [NSNotificationCenter defaultCenter];
    [notifCenter addObserver:self selector:@selector(invokeRemoteLoginNotifications:) name:@"hasBeenLoggedIn" object:nil];
    
    [self toggleLanguage];
    
#if false
    // Create a new gesture
    UIPinchGestureRecognizer pinchRecognizer = new UIPinchGestureRecognizer ();
    // wire up the handler
    pinchRecognizer.AddTarget(() => { HandlePinch(pinchRecognizer); });
    // add the gesture recognizer to the text view
    self.myTextView.AddGestureRecognizer (pinchRecognizer);
#else
    UITapGestureRecognizer *tapGesture = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleTapGesture:)];
    tapGesture.numberOfTapsRequired = 1;
    [self.myTextView addGestureRecognizer:tapGesture];
#endif
    
    [self goLayout];
    
    [notifCenter addObserver:self selector:@selector(invokeRemoteNotifications:) name:@"remoteNotify" object:nil];
    
    if(IBA_ENABLED && IS_PREMIUM && !PUSHER_USE_REGISTRATION && ![LoginViewController registerGet] && ![ViewController dismissGet])
    {
        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_BACKGROUND, 0), ^{
            [NSThread sleepForTimeInterval:5];
            
            dispatch_async(dispatch_get_main_queue(), ^{
                UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:NSLocalizedStringFromTable(@"Warning", [ViewController getLanguageSelected], nil) message:NSLocalizedStringFromTable(@"Vuoi registrarti", [ViewController getLanguageSelected], nil) delegate:self cancelButtonTitle:NSLocalizedStringFromTable(@"non ora", [ViewController getLanguageSelected], nil) otherButtonTitles:NSLocalizedStringFromTable(@"dismetti", [ViewController getLanguageSelected], nil), NSLocalizedStringFromTable(@"registrati", [ViewController getLanguageSelected], nil), nil];
                alertView.tag=1;
                [alertView show];
            });
        });
    }
    
    self.language.hidden = !SHOW_LANGUAGE_SELECTOR;
    
    self.scrollView.contentSize = CGSizeMake(self.view.frame.size.width, self.view.frame.size.height);
    
    //self.scrollView.maximumZoomScale = 2.0f;
    //self.scrollView.delegate = self;
    
    self.personalImage.userInteractionEnabled = YES;
    UITapGestureRecognizer *tapGestureImg = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleTapGestureImage:)];
    tapGestureImg.numberOfTapsRequired = 2;
    [self.personalImage addGestureRecognizer:tapGestureImg];
    
#if false
    [self.newsLabel.layer setBorderColor:[[[UIColor grayColor] colorWithAlphaComponent:0.5] CGColor]];
    [self.newsLabel.layer setBorderWidth:1.0];
#endif
    
    self.newsLabel.hidden = self.newsBack.hidden = !IBA_ENABLED;
    [self showNotifications];
    
    if([[[UIDevice currentDevice] systemVersion] floatValue] >= 7.0)
    {
        self.myTextView.textContainerInset = UIEdgeInsetsZero;
    }
    else
    {
        self.myTextView.contentInset = UIEdgeInsetsMake(0,0,0,0);
    }
    
#ifdef CLICKABLE_SLOGAN_URL
    self.sottotitolo.textColor = [UIColor redColor];
#endif
    
}

-(void) showNotifications
{
    if(IBA_ENABLED)
    {
        //--------------------------------------------------------
        self.innerViewController = [self.storyboard instantiateViewControllerWithIdentifier:@"NotifiesListViewController"];
        self.innerViewController.isEmbedded = YES;
        self.innerViewController.parentController = self;
        self.innerViewController.presenterController = self.innerViewController;
        [self addChildViewController:self.innerViewController];
        self.innerViewController.view.frame = self.containerView.bounds;
        [self.containerView addSubview:self.innerViewController.view];
        [self.innerViewController didMoveToParentViewController:self];
        
        self.innerViewController.myView.backgroundColor = UIColor.clearColor;
        //--------------------------------------------------------
    }
}

-(void) invokeRemoteLoginNotifications:(NSNotification*) notification
{
    if(self.innerViewController)
        [self.innerViewController actionrefresh:nil];
    [self setLogoutAppearance];
}

- (UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView
{
    return self.myTextView;
}

- (void)handleTapGestureImage:(UITapGestureRecognizer *)sender
{
    if (sender.state == UIGestureRecognizerStateRecognized)
    {
        [self magnifyImage:self.personalImage.image/*((UIImageView *)sender.view).image*/];
    }
}

- (void)refreshContainerHeight:(int)height
{
    self.viewsDictionary = @{@"list":self.containerView};
    NSDictionary *metrics = @{@"height":[NSNumber numberWithInt:height]};

    if(self.constraint_H != nil)
        [self.scrollView removeConstraints:self.constraint_H];
    self.constraint_H = [NSLayoutConstraint constraintsWithVisualFormat:@"V:[list(height)]"
                                                                        options:0
                                                                        metrics:metrics
                                                                          views:self.viewsDictionary];
    [self.scrollView addConstraints:self.constraint_H];
    
    self.scrollView.contentSize = CGSizeMake(self.view.frame.size.width, self.view.frame.size.height + self.view.frame.size.height/25.0f + self.view.frame.size.height*(0.12f + 0.1f) + height - self.logo.bounds.size.height);
}

- (IBAction)doLogout:(id)sender
{
    if(![LoginViewController registerGet] || ![LoginViewController loggedInGet])
    {
        UIStoryboard *storyboard = self.storyboard;
        LoginViewController *showViewController = [storyboard instantiateViewControllerWithIdentifier:@"loginID"];
        
        //[ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
        [self presentViewController:showViewController animated:YES completion:nil];
        //[[self navigationController] pushViewController:showViewController animated:YES];
    }
    else
    {
        UIAlertView *alert = [[UIAlertView alloc]initWithTitle:NSLocalizedStringFromTable(@"Logout", [ViewController getLanguageSelected], nil) message:NSLocalizedStringFromTable(@"Sei sicuro di voler effettuare il Logout", [ViewController getLanguageSelected], nil) delegate:self cancelButtonTitle:NSLocalizedStringFromTable(@"No", [ViewController getLanguageSelected], nil) otherButtonTitles:NSLocalizedStringFromTable(@"Si", [ViewController getLanguageSelected], nil), nil];
        alert.tag=2;
        [alert show];
    }
}

-(void) Logout
{
    NSString *errorDesc = nil;
    NSPropertyListFormat format;
    NSString *plistPath;
    NSString *rootPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    
    NSData *plistXML;
    rootPath = [rootPath stringByAppendingPathComponent:@"data.plist"];
    if (![[NSFileManager defaultManager] fileExistsAtPath:rootPath]) {
        plistPath = [[NSBundle mainBundle] pathForResource:@"data" ofType:@"plist"];
        plistXML = [[NSFileManager defaultManager] contentsAtPath:plistPath];
    }
    else plistXML = [[NSFileManager defaultManager] contentsAtPath:rootPath];
    
    NSDictionary *plistDict = (NSDictionary *)[NSPropertyListSerialization
                                               propertyListFromData:plistXML
                                               mutabilityOption:NSPropertyListMutableContainersAndLeaves
                                               format:&format
                                               errorDescription:&errorDesc];
    
    NSString *error;
    
    [plistDict setValue:[NSNumber numberWithBool:NO] forKey:@"isRegistered"];
    
    
    NSData *plistData = [NSPropertyListSerialization dataFromPropertyList:plistDict
                                                                   format:NSPropertyListXMLFormat_v1_0
                                                         errorDescription:&error];
    
#if false
    NSHTTPCookieStorage *storage = [NSHTTPCookieStorage sharedHTTPCookieStorage];
    for (NSHTTPCookie *cookie in [storage cookies]) {
        [storage deleteCookie:cookie];
    }
    [[NSUserDefaults standardUserDefaults] synchronize];
#endif
    
    if(plistData) {
        [plistData writeToFile:rootPath atomically:YES];
        
        [LoginViewController registerSet:NO];
        
        UIStoryboard *storyboard = self.storyboard;
        LoginViewController *showViewController = [storyboard instantiateViewControllerWithIdentifier:@"loginID"];
        
        //[ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
        [self presentViewController:showViewController animated:YES completion:nil];
        //[[self navigationController] pushViewController:showViewController animated:YES];
    }
    else {
        NSLog(error);
        //[error release];
    }
    
    [self setLogoutAppearance];
}

- (IBAction)langAction:(id)sender
{
    languageSelected = ((UIView*)sender).tag;
    [self toggleLanguage];
}

+(NSString*)getLanguageSelected
{
    NSString *table;
    
    switch(languageSelected)
    {
        case 0:
            table = @"italian";
            break;
        case 1:
            table = @"english";
            break;
        case 2:
            table = @"spanish";
            break;
    }

    return table;
}

- (void)toggleLanguage
{
    NSString *table = [ViewController getLanguageSelected];

    self.newsLabel.text = NSLocalizedStringFromTable(@"news e eventi", table, nil);
    self.nome.text = NSLocalizedStringFromTable(@"nome homepage", table, nil);
    self.mansione.text = NSLocalizedStringFromTable(@"mansione", table, nil);
    self.myTextView.text = NSLocalizedStringFromTable(@"descrizione homepage", table, nil);
#if true
    NSString *contString = NSLocalizedStringFromTable(@"continua homepage", table, nil);
    self.descContent = [self.myTextView.text stringByAppendingString:contString];
    self.contRangeLoc = self.myTextView.text.length;
    self.contRangeLen = contString.length;
    
    [self setAttributedText:30];
    
    //[TextViewController fitTextView:self.myTextView outFontSize:&outSize maxFontSize:40];
    
    //self.myTextView.delegate = self;
#endif
    self.titoloUno.text = NSLocalizedStringFromTable(@"titolo homepage", table, nil);
    self.sottotitolo.text = NSLocalizedStringFromTable(@"sottotitolo homepage", table, nil);
}

- (BOOL)textView:(UITextView *)textView shouldInteractWithURL:(NSURL *)URL inRange:(NSRange)characterRange {
    if ([[URL scheme] isEqualToString:@"continua"]) {
        NSString *value = [URL host];
        //show viewcontroller
        return NO;
    }
    return NO; // if u want to let the system open this URL, return YES here
}

-(void) setAttributedText:(NSInteger)size
{
    NSRange contRange = {.location = self.contRangeLoc, .length = self.contRangeLen};
    
    NSMutableParagraphStyle *paragraphStyles = [[NSMutableParagraphStyle alloc] init];
    paragraphStyles.alignment                = NSTextAlignmentJustified;
    paragraphStyles.lineBreakMode            = NSLineBreakByWordWrapping;
    paragraphStyles.firstLineHeadIndent      = 0.001f;
    //paragraphStyles.hyphenationFactor        = 1;
    NSDictionary *attributes                 = @{NSParagraphStyleAttributeName: paragraphStyles};
    
    NSMutableAttributedString *string = [[NSMutableAttributedString alloc]initWithString:self.descContent attributes:attributes];
#if true
    [string addAttribute:NSForegroundColorAttributeName value:[UIColor colorWithRed:5.0/255.0 green:55.0/255.0 blue:134.0/255.0 alpha:1] range:contRange];
    //[string addAttribute:NSFontAttributeName value:[UIFont boldSystemFontOfSize:size] range:contRange];
#else
    [string addAttribute:NSLinkAttributeName value:@"continua://YES" range:contRange];
    NSDictionary *linkAttributes = @{NSForegroundColorAttributeName: [UIColor colorWithRed:5.0/255.0 green:55.0/255.0 blue:134.0/255.0 alpha:1],
                                     NSUnderlineColorAttributeName: [UIColor lightGrayColor],
                                     NSUnderlineStyleAttributeName: @(NSUnderlinePatternSolid)};
    self.myTextView.linkTextAttributes = linkAttributes;
#endif
    [self.myTextView setAttributedText:string];
}

+ (NSRange)rangeFromTextRange:(UITextRange *)textRange inTextView:(UITextView*)textView {
    
    UITextPosition* beginning = textView.beginningOfDocument;
    UITextPosition* start = textRange.start;
    UITextPosition* end = textRange.end;
    
    const NSInteger location = [textView offsetFromPosition:beginning toPosition:start];
    const NSInteger length = [textView offsetFromPosition:start toPosition:end];
    
    return NSMakeRange(location, length);
}

- (void)magnifyImage:(UIImage*)image
{
#if false
    UIStoryboard *storyboard = self.storyboard;
    MagnifyViewController *modalViewController = [storyboard instantiateViewControllerWithIdentifier:@"MagnifyViewController"];
    
    modalViewController.selectedImage = image;
    
    [ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
    [self presentViewController:modalViewController animated:NO completion:nil];
#endif
}

- (void)handleTapGesture:(UITapGestureRecognizer *)sender
{
#if false
    if (sender.state == UIGestureRecognizerStateRecognized)
    {
        [TextViewController magnifyText:self.myTextView.text from:self maxFont:60];
    }
#else
    UITextView *textView =  (UITextView *)sender.view;
    CGPoint location = [sender locationInView:textView];
    //NSLog(@"Tap Gesture Coordinates: %.2f %.2f -- %@", location.x, location.y,textView.text);
    
    CGPoint position = CGPointMake(location.x, location.y);
    //get location in text from textposition at point
    UITextPosition *tapPosition = [textView closestPositionToPoint:position];
    
    //fetch the word at this position (or nil, if not available)
    UITextRange *textRange = [textView.tokenizer rangeEnclosingPosition:tapPosition withGranularity:UITextGranularityWord inDirection:UITextLayoutDirectionRight];
    NSRange range = [ViewController rangeFromTextRange:textRange inTextView:textView];
    NSString *tappedSentence = [textView textInRange:textRange];//[self lineAtPosition:CGPointMake(location.x, location.y)];
    if(range.location + range.length/2 >= self.contRangeLoc && range.location + range.length/2 <= self.contRangeLoc + self.contRangeLen)
    {
        //NSLog(@"selected :%@ -- %@",tappedSentence,tapPosition);
#if false
        UIStoryboard *storyboard = self.storyboard;
        ExplanationViewController *showViewController = [storyboard instantiateViewControllerWithIdentifier:@"ExplanationViewController"];
        
        showViewController.fontSize = outSize;
        //showViewController.notifyItem = item;
        
        //[ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
        [self presentViewController:showViewController animated:YES completion:nil];
        //[[self navigationController] pushViewController:showViewController animated:YES];
#endif
    }
#endif
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)unwindToHomepage:(UIStoryboardSegue *)segue;
{

}

+ (void)setPresentationStyleForSelfController:(UIViewController *)selfController presentingController:(UIViewController *)presentingController
{
    if ([[[UIDevice currentDevice] systemVersion] floatValue] >= 8.0)
    {
        presentingController.providesPresentationContextTransitionStyle = YES;
        presentingController.definesPresentationContext = YES;
        
        [presentingController setModalPresentationStyle:UIModalPresentationOverCurrentContext];
    }
    else
    {
        [selfController setModalPresentationStyle:UIModalPresentationCurrentContext];
        [selfController.navigationController setModalPresentationStyle:UIModalPresentationCurrentContext];
    }
}

- (IBAction)goToSocial:(id)sender
{
    UIStoryboard *storyboard = self.storyboard;
    if(SHOW_VIDEO_PAGE)
    {
        UIStoryboard *storyboard = self.storyboard;
        ChatViewController *showViewController = [storyboard instantiateViewControllerWithIdentifier:@"VideoViewController"];
        
        //showViewController.notifyItem = item;
        
        //[ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
        [self presentViewController:showViewController animated:YES completion:nil];
        //[[self navigationController] pushViewController:showViewController animated:YES];
    }
    else
    {
#if false
        SocialViewController *modalViewController = [storyboard instantiateViewControllerWithIdentifier:@"SocialViewController"];
   
        [ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
        [self presentViewController:modalViewController animated:YES completion:nil];
#endif
    }
}

- (IBAction)goToAdvertise:(id)sender {
#if false
    UIStoryboard *storyboard = self.storyboard;
    SocialViewController *modalViewController = [storyboard instantiateViewControllerWithIdentifier:@"AdvertiseViewController"];
    
    [ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
    [self presentViewController:modalViewController animated:YES completion:nil];
#endif
}

- (void) viewDidLayoutSubviews
{
    CGFloat actualFontSize;
    UILabel *label = self.titoloUno;
    [label.text sizeWithFont:label.font
                 minFontSize:label.minimumFontSize
              actualFontSize:&actualFontSize
                    forWidth:label.bounds.size.width
               lineBreakMode:label.lineBreakMode];
    
    //[TextViewController fitTextView:self.myTextView outFontSize:&outSize maxFontSize:(actualFontSize*0.85f)];
    
    //self.nome.font = [UIFont boldSystemFontOfSize:MIN(MIN(self.sottotitolo.font.pointSize, outSize), self.nome.font.pointSize)];
    //self.mansione.font = [UIFont boldSystemFontOfSize:MIN(MIN(self.sottotitolo.font.pointSize, outSize), self.mansione.font.pointSize)];
    
    [self layoutSottotitolo];
}

-(void)layoutSottotitolo
{
    CGFloat delta1 = self.myTextView.frame.size.height - [self.myTextView sizeThatFits:(CGSizeMake(self.myTextView.frame.size.width, FLT_MAX))].height;
    CGFloat descender = self.myTextView.font.descender;
    delta1 -= descender;
    CGFloat delta2 = self.personalImage.frame.origin.y - (self.myTextView.frame.origin.y + self.myTextView.frame.size.height - delta1);
    CGFloat spacing = (delta2 - self.sottotitolo.frame.size.height)/2 - delta1;
    self.sottotitoloConstraint.constant = spacing;
}

-(void)setLogoutAppearance
{
    if(IS_PREMIUM)
    {
        if(![LoginViewController registerGet] || ![LoginViewController loggedInGet])
            [self.logoutButton setImage:self.loginImage forState:UIControlStateNormal];
        else [self.logoutButton setImage:self.logoutImage forState:UIControlStateNormal];
    }
}

- (void)viewDidAppear:(BOOL)animated
{
    //[TextViewController fitTextView:self.myTextView outFontSize:&outSize maxFontSize:40];
    //[self setAttributedText:outSize];
    
    //[self processNotifies];
    
    if(!IS_PREMIUM)
        self.logoutButton.hidden = YES;
    
    [self setLogoutAppearance];
    [self setIbaButton];
    
#if true
    LoginViewController *lvc =  [[LoginViewController alloc] init];
    if([LoginViewController registerGet] /*&& ![LoginViewController loggedInGet]*/ && ((AppDelegate*)[UIApplication sharedApplication].delegate).token_string)
        [lvc Login:[ChatViewController usernameGet] withPwd:[ChatViewController pwdGet] shouldGoToHomepage:NO];
    
    if(self.innerViewController && (!IS_PREMIUM || [LoginViewController loggedInGet]))
        [self.innerViewController actionrefresh:nil];
#endif
}

- (IBAction)goIBA:(id)sender
{
#if false
    UIStoryboard *storyboard = self.storyboard;
    NotifiesListViewController *showViewController = [storyboard instantiateViewControllerWithIdentifier:@"NotifiesListViewController"];
    
    showViewController.presenterController = showViewController;
    showViewController.isEmbedded = NO;
    [NotifiesListViewController resetBadge];
    
    //[ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
    [self presentViewController:showViewController animated:YES completion:nil];
    //[[self navigationController] pushViewController:showViewController animated:YES];
#else
    UIViewController *uivc = [ViewController visibleViewController];
    ChatViewController *showViewController = [self.storyboard instantiateViewControllerWithIdentifier:@"ChatViewController"];
    
    showViewController.notifyItem = nil;
    
    //[ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
    if(uivc)
        [uivc presentViewController:showViewController animated:YES completion:nil];
    else NSLog(@"VIEWCONTROLLER NULL ---------------");
    //[[self navigationController] pushViewController:showViewController animated:YES];
#endif
}

-(void) goLayout
{
    /*if ([[[UIDevice currentDevice] systemVersion] floatValue] >= 8.0)
     {
     self.firstConstraint.active = !IBA_ENABLED;
     self.firstConstraintTwo.active = IBA_ENABLED;
     self.secondConstraint.active = !IBA_ENABLED;
     self.secondConstraintTwo.active = IBA_ENABLED;
     self.thirdConstraint.active = !IBA_ENABLED;
     self.thirdConstraintTwo.active = IBA_ENABLED;
     self.fourthConstraint.active = !IBA_ENABLED;
     self.fourthConstraintTwo.active = IBA_ENABLED;
     self.fifthConstraint.active = !IBA_ENABLED;
     self.fifthConstraintTwo.active = IBA_ENABLED;
     }
     else*/
    {
        self.viewsDictionary = @{@"superview":self.myView, @"contatti":self.contatti, @"social":self.social, @"foto":self.foto, @"vcard":self.vcard, @"iba":self.ibaButton};
        float const1 = (!IBA_ENABLED)?(1.0f/5.0f):(0.8f/7.0f);
        float const2 = (!IBA_ENABLED)?(2.0f/5.0f):(2.15f/7.0f);
        float const3 = (!IBA_ENABLED)?(3.0f/5.0f):(3.5f/7.0f);
        float const4 = (!IBA_ENABLED)?(3.0f/5.0f):(4.85f/7.0f);
        float const5 = (!IBA_ENABLED)?(4.0f/5.0f):(6.2f/7.0f);
        
        [self.myView addConstraint:[NSLayoutConstraint
                                    constraintWithItem:self.foto
                                    attribute:NSLayoutAttributeCenterX
                                    relatedBy:NSLayoutRelationEqual
                                    toItem:self.myView
                                    attribute:NSLayoutAttributeTrailing
                                    multiplier:const1
                                    constant:0.0]];
        [self.myView addConstraint:[NSLayoutConstraint
                                    constraintWithItem:self.social
                                    attribute:NSLayoutAttributeCenterX
                                    relatedBy:NSLayoutRelationEqual
                                    toItem:self.myView
                                    attribute:NSLayoutAttributeTrailing
                                    multiplier:const2
                                    constant:0.0]];
        [self.myView addConstraint:[NSLayoutConstraint
                                    constraintWithItem:self.ibaButton
                                    attribute:NSLayoutAttributeCenterX
                                    relatedBy:NSLayoutRelationEqual
                                    toItem:self.myView
                                    attribute:NSLayoutAttributeTrailing
                                    multiplier:const3
                                    constant:0.0]];
        [self.myView addConstraint:[NSLayoutConstraint
                                    constraintWithItem:self.contatti
                                    attribute:NSLayoutAttributeCenterX
                                    relatedBy:NSLayoutRelationEqual
                                    toItem:self.myView
                                    attribute:NSLayoutAttributeTrailing
                                    multiplier:const4
                                    constant:0.0]];
        [self.myView addConstraint:[NSLayoutConstraint
                                    constraintWithItem:self.vcard
                                    attribute:NSLayoutAttributeCenterX
                                    relatedBy:NSLayoutRelationEqual
                                    toItem:self.myView
                                    attribute:NSLayoutAttributeTrailing
                                    multiplier:const5
                                    constant:0.0]];
    }
  
    
    //-------------------------------------
    UIView *spacer1 = [UIView new];
    spacer1.translatesAutoresizingMaskIntoConstraints = NO;
    [self.scrollView addSubview:spacer1];
    
    UIView *spacer2 = [UIView new];
    spacer2.translatesAutoresizingMaskIntoConstraints = NO;
    [self.scrollView addSubview:spacer2];
    
    UIView *spacer3 = [UIView new];
    spacer3.translatesAutoresizingMaskIntoConstraints = NO;
    [self.scrollView addSubview:spacer3];
    
    UIView *spacer4 = [UIView new];
    spacer4.translatesAutoresizingMaskIntoConstraints = NO;
    [self.scrollView addSubview:spacer4];
    
    NSDictionary* viewDict = @{@"spacer1":spacer1, @"spacer2":spacer2, @"spacer3":spacer3, @"spacer4":spacer4, @"spacerBot":self.spacerBot, @"spacerTop":self.spacerTop, @"nome":self.nome, @"mansione":self.mansione, @"language":self.language};
    
    [self.scrollView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"V:[spacerTop][spacer1][nome][spacer2(==spacer1)][mansione][spacer3(==spacer1)][language][spacer4(==spacer1)][spacerBot]" options:0 metrics:0 views:viewDict]];
    //-------------------------------------
    
    
    self.ibaButton.hidden = !IBA_ENABLED;
  
    [self setIbaButton];
    [self setVideoButton];
}

- (IBAction)gogo:(id)sender
{
    [self jumpToNotifies:@""/*@"ed0b534b1be7108afb0c4d6f1f370f63"*/];
}

-(void) setIbaButton
{
    NSString* content = [NotifiesListViewController readFromTextFile:@"notifica.txt"];
    NSMutableArray *notifyList = [[NSMutableArray alloc] init];
    if(content)
        [NotifiesListViewController populate:content onList:notifyList];
    AppDelegate *delegate = [UIApplication sharedApplication].delegate;
    bool hasNews = delegate.showNotifies || delegate.alertArrived || ([UIApplication sharedApplication].applicationIconBadgeNumber > 0);
    for(int i = 0; i < notifyList.count; i++)
    {
        NotifyItem *item = [notifyList objectAtIndex:i];
        if(!item.isRead || item.newMessages > 0)
        {
            hasNews = YES;
            break;
        }
    }
    UIImage *image = [UIImage imageNamed:hasNews?@"button5_new.png":@"button5.png"];
    
    [self.ibaButton setImage:image forState:UIControlStateNormal];
    self.ibaButton.contentHorizontalAlignment = UIControlContentHorizontalAlignmentFill;
    self.ibaButton.contentVerticalAlignment = UIControlContentVerticalAlignmentFill;
}

-(void) setVideoButton
{
    UIImage *image = [UIImage imageNamed:SHOW_VIDEO_PAGE?@"videoButton.png":@"button2.png"];
    
    [self.social setImage:image forState:UIControlStateNormal];
    self.social.contentHorizontalAlignment = UIControlContentHorizontalAlignmentFill;
    self.social.contentVerticalAlignment = UIControlContentVerticalAlignmentFill;
}

BOOL authenticated = NO;

+ (UIViewController *)visibleViewController {
    AppDelegate *delegate = [UIApplication sharedApplication].delegate;
    UIViewController *rootViewController = delegate.window.rootViewController;
    return [ViewController getVisibleViewControllerFrom:rootViewController];
}

+ (UIViewController *) getVisibleViewControllerFrom:(UIViewController *) vc {
    if ([vc isKindOfClass:[UINavigationController class]]) {
        return [ViewController getVisibleViewControllerFrom:[((UINavigationController *) vc) visibleViewController]];
    } else if ([vc isKindOfClass:[UITabBarController class]]) {
        return [ViewController getVisibleViewControllerFrom:[((UITabBarController *) vc) selectedViewController]];
    } else {
        if (vc.presentedViewController) {
            return [ViewController getVisibleViewControllerFrom:vc.presentedViewController];
        } else {
            return vc;
        }
    }
}

-(void) processNotifies:(NSString*)eventCode
{
    AppDelegate *delegate = [UIApplication sharedApplication].delegate;
    
    if(delegate.showNotifies)
    {
        [self jumpToNotifies:eventCode];
    }
    else if(delegate.alertArrived)
    {
        UIViewController *uivc = [ViewController visibleViewController];
        if(uivc && [uivc isKindOfClass:[ChatViewController class]])
        {
        }
        else if(uivc && [uivc isKindOfClass:[NotifiesListViewController class]])
        {
            [((NotifiesListViewController*)uivc) actionrefresh:nil];
        }
        else
        {
            if(uivc && [uivc isKindOfClass:[ViewController class]])
                if(((ViewController*)uivc).innerViewController)
                {
                    [((ViewController*)uivc).innerViewController actionrefresh:nil];
                    [self setIbaButton];
                }
            
            self.notifiedEventCode = eventCode;
            [self showNewContentAlert];
        }
    }
    delegate.showNotifies = NO;
    delegate.alertArrived = NO;
}

-(void) invokeRemoteNotifications:(NSNotification*) notification
{
    NSString *eventCode = nil;
    if(notification && notification.userInfo)
        if([notification.userInfo objectForKey:@"event_code"])
            eventCode = [notification.userInfo objectForKey:@"event_code"];

    [self processNotifies:eventCode];
}

- (void)jumpToNotifies:(NSString*)jumpToEvent
{
#if false
    UIStoryboard *storyboard = self.storyboard;
    NotifiesListViewController *showViewController = [storyboard instantiateViewControllerWithIdentifier:@"NotifiesListViewController"];
    
    showViewController.isEmbedded = NO;
    showViewController.presenterController = showViewController;
    [NotifiesListViewController resetBadge];
    showViewController.jumpToEvent = jumpToEvent;
    
    //[ViewController setPresentationStyleForSelfController:self presentingController:modalViewController];
    [self presentViewController:showViewController animated:YES completion:nil];
    //[[self navigationController] pushViewController:showViewController animated:YES];
#else
    UIStoryboard *storyboard = self.storyboard;
    NotifiesListViewController *showViewController = [storyboard instantiateViewControllerWithIdentifier:@"NotifiesListViewController"];
    
    showViewController.isEmbedded = NO;
    [NotifiesListViewController resetBadge];
    showViewController.jumpToEvent = jumpToEvent;
    showViewController.presenterController = self;
    
    showViewController.notifyList = [[NSMutableArray alloc] init];
    [showViewController refreshList:showViewController.notifyList initPopulation:NO jumpToEvent:jumpToEvent];
#endif
}

- (void) showNewContentAlert
{
    UIAlertView *alert = [[UIAlertView alloc]initWithTitle:NSLocalizedStringFromTable(@"Nuovi contenuti", [ViewController getLanguageSelected], nil) message:NSLocalizedStringFromTable(@"Sono disponibili nuovi annunci", [ViewController getLanguageSelected], nil) delegate:self cancelButtonTitle:NSLocalizedStringFromTable(@"Esci", [ViewController getLanguageSelected], nil) otherButtonTitles:NSLocalizedStringFromTable(@"Guarda Annunci", [ViewController getLanguageSelected], nil), nil];
    [self setIbaButton];
    alert.tag=0;
    [alert show];
}
                                                                                                                                                                                                                                                                                                                                                                                                                        
+ (BOOL)dismissGet
{
    return dismiss;
}

+ (void)dismissSet:(bool)reg
{
    dismiss = reg;
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if(alertView.tag == 0)
    {
        if (buttonIndex == 0)
        {
            //Exit
        }
        if (buttonIndex == 1)
        {
            [self jumpToNotifies:self.notifiedEventCode];
        }
    }
    else if(alertView.tag == 1)
    {
        if(buttonIndex == 1)//dismetti button pressed
        {
            NSString *errorDesc = nil;
            NSPropertyListFormat format;
            NSString *plistPath;
            NSString *rootPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
            NSData *plistXML;
            rootPath = [rootPath stringByAppendingPathComponent:@"data.plist"];
            if (![[NSFileManager defaultManager] fileExistsAtPath:rootPath]) {
                plistPath = [[NSBundle mainBundle] pathForResource:@"data" ofType:@"plist"];
                plistXML = [[NSFileManager defaultManager] contentsAtPath:plistPath];
            }
            else plistXML = [[NSFileManager defaultManager] contentsAtPath:rootPath];
            
            NSDictionary *plistDict = (NSDictionary *)[NSPropertyListSerialization
                                                       propertyListFromData:plistXML
                                                       mutabilityOption:NSPropertyListMutableContainersAndLeaves
                                                       format:&format
                                                       errorDescription:&errorDesc];
            
            NSString *error;
            

            [plistDict setValue:[NSNumber numberWithBool:YES] forKey:@"dismiss"];

            
            NSData *plistData = [NSPropertyListSerialization dataFromPropertyList:plistDict
                                                                           format:NSPropertyListXMLFormat_v1_0
                                                                 errorDescription:&error];
           
            if(plistData) {
                [plistData writeToFile:rootPath atomically:YES];            
            }
            else {
                NSLog(error);
                //[error release];
            }
        }
        if(buttonIndex == 2)//registrati button pressed
        {
            [self performSegueWithIdentifier:@"showLoginSegue" sender:self];
        }
    }
    else if(alertView.tag == 2)
    {
        if(buttonIndex == 1)//OK button pressed
        {
            [self Logout];
        }
    }
}

- (IBAction)goSlogan:(id)sender
{
#ifdef CLICKABLE_SLOGAN_URL
    [InfoPageViewController openWeb:CLICKABLE_SLOGAN_URL];
#endif
}

@end
